Attribute VB_Name = "ControlNames"
Public FileAdjust As Integer
Public Total As Long
Public OutLit, MiniLit As Boolean
Public WinList(50) As Integer
'---------------
 Declare Function Ctl3dRegister Lib "CTL3D.DLL" (ByVal hInstance As Integer) As Integer
 Declare Function Ctl3dAutoSubClass Lib "CTL3D.DLL" (ByVal hInstance As Integer) As Integer
 Declare Function Ctl3dUnregister Lib "CTL3D.DLL" (ByVal hInstance As Integer) As Integer
'The above Lines add 3D look to the common dialogs

Public RPatch(643)

Public PatComp_A(644) As Integer
Public PatComp_B(644) As Integer

Public GMSet As Integer
Global lpMidiIn As Long
Global lpMidiOut As Long

Public Cat1, Cat2 As Integer
Public MaxSubs As Integer
Public CatList(256) As Integer
Public SubCatList(512) As Integer
Public CatListCount As Integer
Public SubCatListCount As Integer

Type PatchRecord
    Valid As Boolean
    IDRec As Long
    PatchData As String * 644
End Type

Type PerfRecord
    Valid As Boolean
    IDRec As Long
    PatchData As String * 14639  '<-----------error
End Type

Type RhytRecord
    Valid As Boolean
    IDRec As Long
    PatchData As String * 4439  '<-----------error
End Type

Declare Function GetWindowsDirectory Lib "kernel" (ByVal p$, ByVal s%) As Integer
'Declare Function GetSystemDirectory Lib "kernel" (ByVal P$, ByVal S%) As Integer

Public FileLen As Long
Public Model, XPShift, XP_P_Shift As Integer
Public PatchLen, PartLen, PerfLen, RhytLen, FullPerfLen As Long
Public Col_shift, Selector(15) As Integer

Public ToneActive(3) As Boolean
Public PartActive(16) As Boolean
Public Reading As Boolean
Public RhythmNote As Integer

Public PShift As Long

Public LastNote As Integer
Public Volume As Integer
Public QueryNames As Boolean

Public EFX_Caller As Integer
Public x1, y1, x2, y2, x3, y3, x4, y4, x5, y5 As Integer
Public x01, y01, x02, y02, x03, y03, x04, y04, x05, y05 As Integer

Public fx1, fx2, fx3, fx4, fx5, fy1, fy2, fy3, fy4, fy5 As Integer
Public fx01, fx02, fx03, fx04, fx05, fy01, fy02, fy03, fy04, fy05 As Integer

Public Ax1, Ax2, Ax3, Ax4, Ax5, Ay1, Ay2, Ay3, Ay4, Ay5 As Integer
Public Ax01, Ax02, Ax03, Ax04, Ax05, Ay01, Ay02, Ay03, Ay04, Ay05 As Integer

'---------------
Public Rx1, Ry1, Rx2, Ry2, Rx3, Ry3, Rx4, Ry4, Rx5, Ry5 As Integer
Public Rx01, Ry01, Rx02, Ry02, Rx03, Ry03, Rx04, Ry04, Rx05, Ry05 As Integer

Public Rfx1, Rfx2, Rfx3, Rfx4, Rfx5, Rfy1, Rfy2, Rfy3, Rfy4, Rfy5 As Integer
Public Rfx01, Rfx02, Rfx03, Rfx04, Rfx05, Rfy01, Rfy02, Rfy03, Rfy04, Rfy05 As Integer

Public RAx1, RAx2, RAx3, RAx4, RAx5, RAy1, RAy2, RAy3, RAy4, RAy5 As Integer
Public RAx01, RAx02, RAx03, RAx04, RAx05, RAy01, RAy02, RAy03, RAy04, RAy05 As Integer

'---------------

Public XYset As Integer
Public W As Integer

Public PatchDown As Long
Public SwapName As String
Public Block, PatchSet As Integer
Public TempWindow As Boolean

Public MidiInPort As Integer
Public MidiOutPort As Integer
Public Midi_Thru As Integer
Public AutoShowX As Integer
Public AutoSend As Integer
Public AutoNames As Integer
Public PatchListNumber As Integer
Public AutoCode As Integer
Public DeviceID As Integer
Public AutoQuery As Integer
Public Exp_A, Exp_B, Exp_C, Exp_D, PCM As Integer
Public PCMEnabled As Integer
Public GetMidiValues As Integer

Public ConfigExist As Integer
Public MIDICardExists As Integer

Public TempIndex As Integer
Public TempBuffer(645) As Byte
Public FixBuffer(100000) As Byte
Public TempBufferActive As Boolean

Public ToneIndex As Integer
Public PartIndex As Integer
Public TuneIndex As Integer
Public PartID As String
Public RhythmID As String
Public Finishing As Boolean

Public KeepWaiting As Boolean

Public SysexBytes As String
Public SysexListCount As Long
Public Sysexbuffer(128000) As Byte
Public TempNames(127) As String
Public TempPatchName As String

Public BufferIndex As Long
Public LastCode As String
Public ControlChange As String
Public PatchNum As Integer
Public FileLoaded As Boolean

Public InMessage As Integer
Public InData1 As Integer
Public InData2 As Integer

Public Sub qq()
Dim i As Integer

For i = 0 To WinIndex - 1
    Debug.Print WinList(i)
Next
Debug.Print "----------------"

End Sub


Public Sub SetAdjust(p As Long)

    If p = 82304 Then               'JV file
        If Model = 0 Then               'JV
            FileAdjust = 0
        Else                            'XP
            FileAdjust = -1
        End If
    ElseIf p = 82432 Then           'XP file
        If Model = 0 Then              'JV
            FileAdjust = 1
        Else                           'XP
            FileAdjust = 0
        End If
    End If

End Sub

Public Sub ToneReset()
        Form1.T1.BackColor = &HC0C0C0      'Gris
        Form1.T2.BackColor = &HC0C0C0      'Gris
        Form1.T3.BackColor = &HC0C0C0      'Gris
        Form1.T4.BackColor = &HC0C0C0      'Gris
End Sub

Public Sub ToneSet()
    
    If Sysexbuffer(92 + XPShift) = 1 Then      'Tone switch 1
        Form1.T1.BackColor = &H80FFFF                'Rojo
    Else
        Form1.T1.BackColor = &HC0C0C0      'Gris
    End If
    
    If Sysexbuffer(92 + 140 + XPShift) = 1 Then      'Tone switch 1
        Form1.T2.BackColor = &H80FFFF                'Rojo
    Else
        Form1.T2.BackColor = &HC0C0C0     'Gris
    End If
    
    If Sysexbuffer(92 + 2 * 140 + XPShift) = 1 Then     'Tone switch 1
        Form1.T3.BackColor = &H80FFFF                'Rojo
    Else
        Form1.T3.BackColor = &HC0C0C0      'Gris
    End If
    
    If Sysexbuffer(92 + 3 * 140 + XPShift) = 1 Then     'Tone switch 1
        Form1.T4.BackColor = &H80FFFF                'Rojo
    Else
        Form1.T4.BackColor = &HC0C0C0      'Gris
    End If

End Sub

Public Function TypeFile(n As Integer) As String
Select Case n
    Case &H0: TypeFile = "System "
    Case &H1: TypeFile = "Performance "
    Case &H2: TypeFile = "Rhythm Set "
    Case &H3: TypeFile = "Patch "
    Case &H10: TypeFile = "Performance Bank "
    Case &H11: TypeFile = "Patch Bank "
    Case Else: TypeFile = "Unknow "
End Select

End Function

Public Sub WinCloseAll()
    If WinList(0) Then Unload AboutForm
    If WinList(1) Then Unload ChorusDelay
    If WinList(2) Then Unload ChorusFlanger
    If WinList(3) Then Unload Compressor
    If WinList(4) Then Unload CONT
    
    If WinList(5) Then Unload EFXStereoEQ
    If WinList(6) Then Unload EFXAutowah
    If WinList(7) Then Unload EFXOVERD
    If WinList(8) Then Unload EFXRotary
    If WinList(9) Then Unload EFXSpectrum
    
    If WinList(10) Then Unload Enhancer
    If WinList(11) Then Unload ENHChorus
    If WinList(12) Then Unload ENHDelay
    If WinList(13) Then Unload ENHFlanger
    If WinList(14) Then Unload FBKPShifter
    
    If WinList(15) Then Unload FlangerDelay
    If WinList(16) Then Unload Form2
    If WinList(17) Then Unload ReceiveForm
    If WinList(18) Then Unload GateReverb
    If WinList(19) Then Unload Common
    
    If WinList(20) Then Unload HexaChorus
    If WinList(21) Then Unload LayOut
    If WinList(22) Then Unload MDIForm1
    If WinList(23) Then Unload Limiter
    If WinList(24) Then Unload ModDelay
    
    If WinList(25) Then Unload outline
    If WinList(26) Then Unload OverChorus
    If WinList(27) Then Unload OverDelay
    If WinList(28) Then Unload OverFlanger
    If WinList(29) Then Unload PerformanceCommon
    
    If WinList(30) Then Unload Phaser
    If WinList(31) Then Unload pitch
    If WinList(32) Then Unload QTapDelay
    If WinList(33) Then Unload Reverb
    If WinList(34) Then Unload RGenerator
    
    If WinList(35) Then Unload RHYTHM
    If WinList(36) Then Unload SendCodeForm
    If WinList(37) Then Unload SetupForm
    If WinList(38) Then Unload SPACED
    If WinList(39) Then Unload STChorus
    
    If WinList(40) Then Unload STDelay
    If WinList(41) Then Unload StepFlanger
    If WinList(42) Then Unload STFlanger
    If WinList(43) Then Unload System
    If WinList(44) Then Unload TCDelay
    
    If WinList(45) Then Unload Tones
    If WinList(46) Then Unload TREMOLO
    If WinList(47) Then Unload TTapDelay
    If WinList(48) Then Unload VPShifter
    If WinList(49) Then Unload Chorus_Pane
    If WinList(50) Then Unload Reverb_Pane
    
End Sub

'Function SystemDirectory() As String
'Dim WinPath As String
'    WinPath = String(145, Chr(0))
'    SystemDirectory = Left(WinPath, GetSystemDirectory(WinPath, Len(WinPath)))
'End Function

Function WindowsDirectory() As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    WindowsDirectory = Left(WinPath, GetWindowsDirectory(WinPath, Len(WinPath)))
End Function

Public Function KeyCode(Index)
Dim s As String

Select Case Index
    Case 0: s = "C-1"
    Case 1: s = "C#-1"
    Case 2: s = "D-1"
    Case 3: s = "D#-1"
    Case 4: s = "E-1"
    Case 5: s = "F-1"
    Case 6: s = "F#-1"
    Case 7: s = "G-1"
    Case 8: s = "G#-1"
    Case 9: s = "A-1"
    Case 10: s = "A#-1"
    Case 11: s = "B-1"
    Case 12: s = "C0"
    Case 13: s = "C#0"
    Case 14: s = "D0"
    Case 15: s = "D#0"
    Case 16: s = "E0"
    Case 17: s = "F0"
    Case 18: s = "F#0"
    Case 19: s = "G0"
    Case 20: s = "G#0"
    Case 21: s = "A0"
    Case 22: s = "A#0"
    Case 23: s = "B0"
    Case 24: s = "C1"
    Case 25: s = "C#1"
    Case 26: s = "D1"
    Case 27: s = "D#1"
    Case 28: s = "E1"
    Case 29: s = "F1"
    Case 30: s = "F#1"
    Case 31: s = "G1"
    Case 32: s = "G#1"
    Case 33: s = "A1"
    Case 34: s = "A#1"
    Case 35: s = "B1"
    Case 36: s = "C2"
    Case 37: s = "C#2"
    Case 38: s = "D2"
    Case 39: s = "D#2"
    Case 40: s = "E2"
    Case 41: s = "F2"
    Case 42: s = "F#2"
    Case 43: s = "G2"
    Case 44: s = "G#2"
    Case 45: s = "A2"
    Case 46: s = "A#2"
    Case 47: s = "B2"
    Case 48: s = "C3"
    Case 49: s = "C#3"
    Case 50: s = "D3"
    Case 51: s = "D#3"
    Case 52: s = "E3"
    Case 53: s = "F3"
    Case 54: s = "F#3"
    Case 55: s = "G3"
    Case 56: s = "G#3"
    Case 57: s = "A3"
    Case 58: s = "A#3"
    Case 59: s = "B3"
    Case 60: s = "C4"
    Case 61: s = "C#4"
    Case 62: s = "D4"
    Case 63: s = "D#4"
    Case 64: s = "E4"
    Case 65: s = "F4"
    Case 66: s = "F#4"
    Case 67: s = "G4"
    Case 68: s = "G#4"
    Case 69: s = "A4"
    Case 70: s = "A#4"
    Case 71: s = "B4"
    Case 72: s = "C5"
    Case 73: s = "C#5"
    Case 74: s = "D5"
    Case 75: s = "D#5"
    Case 76: s = "E5"
    Case 77: s = "F5"
    Case 78: s = "F#5"
    Case 79: s = "G5"
    Case 80: s = "G#5"
    Case 81: s = "A5"
    Case 82: s = "A#5"
    Case 83: s = "B5"
    Case 84: s = "C6"
    Case 85: s = "C#6"
    Case 86: s = "D6"
    Case 87: s = "D#6"
    Case 88: s = "E6"
    Case 89: s = "F6"
    Case 90: s = "F#6"
    Case 91: s = "G6"
    Case 92: s = "G#6"
    Case 93: s = "A6"
    Case 94: s = "A#6"
    Case 95: s = "B6"
    Case 96: s = "C7"
    Case 97: s = "C#7"
    Case 98: s = "D7"
    Case 99: s = "D#7"
    Case 100: s = "E7"
    Case 101: s = "F7"
    Case 102: s = "F#7"
    Case 103: s = "G7"
    Case 104: s = "G#7"
    Case 105: s = "A7"
    Case 106: s = "A#7"
    Case 107: s = "B7"
    Case 108: s = "C8"
    Case 109: s = "C#8"
    Case 110: s = "D8"
    Case 111: s = "D#8"
    Case 112: s = "E8"
    Case 113: s = "F8"
    Case 114: s = "F#8"
    Case 115: s = "G8"
    Case 116: s = "G#8"
    Case 117: s = "A8"
    Case 118: s = "A#8"
    Case 119: s = "B8"
    Case 120: s = "C9"
    Case 121: s = "C#9"
    Case 122: s = "D9"
    Case 123: s = "D#9"
    Case 124: s = "E9"
    Case 125: s = "F9"
    Case 126: s = "F#9"
    Case 127: s = "G9"
End Select
KeyCode = s
End Function



 
Public Sub ExpansionNames(Index As Integer)
Dim Key As Integer
Dim Combo As ComboBox
Set Combo = Form1.PatchNames

Select Case Index
        Case 1: Key = Exp_A
        Case 2: Key = Exp_B
        Case 3: Key = Exp_C
        Case 4: Key = Exp_D
End Select
        
Select Case Key
        Case 0: Form1.OptionPreset = True: Form1.Bank_A = True
        Case 1: Form1.FillNames_Pop Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 144
        Case 2: Form1.FillNames_Orch Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 173
        Case 3: Form1.FillNames_Piano Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 72
        Case 4: Form1.FillNames_Vintage_A Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
        Case 5: Form1.FillNames_World Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
        Case 6: Form1.FillNames_Dance Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
        Case 7: Form1.FillNames_Super Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
        Case 8: Form1.FillNames_6070s Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
        Case 9: Form1.FillNames_Session Combo
                Form1.VScroll1 = 0
                Form1.VScroll1.Max = 254
End Select
'Form1.PatchNames.ListIndex = 0
End Sub


Public Sub TestKeyDown(Button As Integer)
Dim Event As MidiEvent, rc As Variant

If LastNote = 0 Then
    LastNote = &H33
Else
    LastNote = LastNote + 12
    If LastNote > &H57 Then LastNote = &H33
End If

If Button = 1 Then
        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote)
        Event.data2 = Chr$(Volume)
        rc = PutMidiOut(lpMidiOut, Event)
Else
        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote - 5)
        Event.data2 = Chr$(Volume)
        rc = PutMidiOut(lpMidiOut, Event)

        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote - 10)
        Event.data2 = Chr$(Volume)
        rc = PutMidiOut(lpMidiOut, Event)
End If
End Sub
Public Sub TestKeyUp(Button As Integer)
Dim Event As MidiEvent, rc As Variant

If Button = 1 Then
        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote)
        Event.data2 = Chr$(&H0)
        rc = PutMidiOut(lpMidiOut, Event)
Else
        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote - 5)
        Event.data2 = Chr$(&H0)
        rc = PutMidiOut(lpMidiOut, Event)
        
        Event.status = Chr$(&H90)
        Event.data1 = Chr$(LastNote - 10)
        Event.data2 = Chr$(&H0)
        rc = PutMidiOut(lpMidiOut, Event)
End If
End Sub



Public Sub DragEnvelope(X As Integer, Y As Integer)
Dim Fire As Boolean
Dim delta As Integer
Dim W As Integer
W = 6

Picture1.Circle (x1, y1), W, &HC0C0C0             'Erase ticks
Picture1.Circle (x2, y2), W, &HC0C0C0
Picture1.Circle (x3, y3), W, &HC0C0C0
Picture1.Circle (x4, y4), W, &HC0C0C0
    x01 = x1: y01 = y1
    x02 = x2: y02 = y2
    x03 = x3: y03 = y3
    x04 = x4: y04 = y4
    x05 = x5: y05 = y5

If XYset = 1 Then
    If X > 127 Then X = 127
    x1 = X: y1 = Y: Fire = True
ElseIf XYset = 2 Then
    If X < x1 Then
        MsgBox ("X Value too small")
        Exit Sub
    End If
    If X > x1 + 127 Then: X = x1 + 127
    x2 = X: y2 = Y: Fire = True
ElseIf XYset = 3 Then
    If X < x2 Then
        MsgBox ("X Value too small")
        Exit Sub
    End If
    If X > x2 + 127 Then: X = x2 + 127
    x3 = X: y3 = Y: Fire = True
ElseIf XYset = 4 Then
    If X < x3 Then
        MsgBox ("You can't do that")
        Exit Sub
    End If
    If X > x3 + 127 Then: X = x3 + 127
    x4 = X: y4 = Y: Fire = True
Else
    Fire = False
End If

If x01 <> x1 Then           'To drag the lines
    delta = x01 - x1
    x2 = x2 - delta: x3 = x3 - delta: x4 = x4 - delta: x5 = x5 - delta
ElseIf x02 <> x2 Then
    delta = x02 - x2
    x3 = x3 - delta: x4 = x4 - delta: x5 = x5 - delta
ElseIf x03 <> x3 Then
    delta = x03 - x3
    x4 = x4 - delta: x5 = x5 - delta
ElseIf x04 <> x4 Then
    delta = x04 - x4
    x5 = x5 - delta
End If

If Fire Then
    Picture1.Line (0, 0)-(x01, y01), &HC0C0C0
    Picture1.Line -(x02, y02), &HC0C0C0
    Picture1.Line -(x03, y03), &HC0C0C0
    Picture1.Line -(x04, y04), &HC0C0C0
    Picture1.Line -(x05, 0), &HC0C0C0

    Picture1.Line (0, 0)-(x1, y1), &H0&
    Picture1.Line -(x2, y2), &H0&
    Picture1.Line -(x3, y3), &H0&
    Picture1.Line -(x4, y4), &H0&
    Picture1.Line -(x5, 0), &H0&
End If
Picture1.Circle (x1, y1), W, &H0&   'Draw tick Marks on points
Picture1.Circle (x2, y2), W, &H0&
Picture1.Circle (x3, y3), W, &H0&
Picture1.Circle (x4, y4), W, &H0&

End Sub



Public Sub EFXGain(Index As Integer)
If AutoCode Then
    If EFX_Caller = 0 Then
        Form1.Send ("12 03 00 00 11 " & FillCode(Hex(Index)))
    ElseIf EFX_Caller = 1 Then
        Form1.Send ("12 01 00 00 12 " & FillCode(Hex(Index)))
    End If
End If

End Sub



Public Sub EFXRatio(Index As Integer)
If AutoCode Then
    If EFX_Caller = 0 Then
        Form1.Send ("12 03 00 00 0F " & FillCode(Hex(Index)))
    ElseIf EFX_Caller = 1 Then
        Form1.Send ("12 01 00 00 10 " & FillCode(Hex(Index)))
    End If
End If

End Sub


Public Sub EFXSelect(Index As Integer)
    Select Case Index
        Case 0: EFXStereoEQ.Show 1
        Case 1
            Load EFXOVERD: EFXOVERD.Caption = "OVERDRIVE"
            EFXOVERD.Show 1
        Case 2
            Load EFXOVERD: EFXOVERD.Caption = "DISTORTION"
            EFXOVERD.Show 1
        Case 3: Phaser.Show 1
        Case 4: EFXSpectrum.Show 1
        Case 5: Enhancer.Show 1
        Case 6: EFXAutowah.Show 1
        Case 7: EFXRotary.Show 1
        Case 8: Compressor.Show 1
        Case 9: Limiter.Show 1
        Case 10: HexaChorus.Show 1
        Case 11: TREMOLO.Show 1
        Case 12: SPACED.Show 1
        Case 13: STChorus.Show 1
        Case 14: STFlanger.Show 1
        Case 15: StepFlanger.Show 1
        Case 16: STDelay.Show 1
        Case 17: ModDelay.Show 1
        Case 18: TTapDelay.Show 1
        Case 19: QTapDelay.Show 1
        Case 20: TCDelay.Show 1
        Case 21: VPShifter.Show 1
        Case 22: FBKPShifter.Show 1
        Case 23: Reverb.Show 1
        Case 24: GateReverb.Show 1
        Case 25: OverChorus.Show 1
        Case 26: OverFlanger.Show 1
        Case 27: OverDelay.Show 1
        Case 28: Load OverChorus: OverChorus.Caption = "Distortion -> Chorus"
                 OverChorus.Show 1
        Case 29: Load OverFlanger: OverFlanger.Caption = "Distortion -> Flanger"
                 OverFlanger.Show 1
        Case 30: Load OverDelay: OverDelay.Caption = "Distortion -> Delay"
                 OverDelay.Show 1
        Case 31: ENHChorus.Show 1
        Case 32: ENHFlanger.Show 1
        Case 33: ENHDelay.Show 1
        Case 34: ChorusDelay.Show 1
        Case 35: FlangerDelay.Show 1
        Case 36: ChorusFlanger.Show 1
        Case 37: Load ChorusDelay: ChorusDelay.Caption = "Chorus / Delay"
                ChorusDelay.Show 1
        Case 38: Load FlangerDelay: FlangerDelay.Caption = "Flanger / Delay"
                FlangerDelay.Show 1
        Case 39: Load ChorusFlanger: ChorusFlanger.Caption = "Chorus / Flanger"
                ChorusFlanger.Show 1
        Case Else: MsgBox ("Effect not implemented yet")
    End Select

End Sub


Public Sub EFXspeed(Index As Integer)
If AutoCode Then
    If EFX_Caller = 0 Then
        Form1.Send ("12 03 00 00 11 " & FillCode(Hex(Index)))
    ElseIf EFX_Caller = 1 Then
        Form1.Send ("12 01 00 00 12 " & FillCode(Hex(Index)))
    End If
End If

End Sub

Public Function FillCode(Code As String)
If Len(Trim(Code)) = 1 Then
    FillCode = ("0" & Code)
Else
    FillCode = Code
End If

End Function

Public Sub Filter_Type(Index)
If AutoCode Then
    If EFX_Caller = 0 Then
        Form1.Send ("12 03 00 00 0D " & FillCode(Hex(Index)))
    ElseIf EFX_Caller = 1 Then
        Form1.Send ("12 01 00 00 0E " & FillCode(Hex(Index)))
    End If
End If
End Sub

Public Function LoadFile(FileName As String) As Integer
Dim s As String, i, BytesPending, ReadBlock, Index As Long

On Error Resume Next

Open FileName For Binary As #1
p = LOF(1): FileLen = p
Form2.Show
    BytesPending = p: Index = 0
    Do While Index < p
        If BytesPending < 10000 Then
            ReadBlock = BytesPending
        Else
            ReadBlock = 10000
        End If
        BytesPending = BytesPending - ReadBlock
        s = InputB(ReadBlock, 1)
        For i = 1 To ReadBlock
            Sysexbuffer(i - 1 + Index) = Asc(Mid(s, i, 1))
            If (i Mod 1000) = 0 Then
                Form2.Progress (CByte((Index + i) / p * 100))
            End If
            'DoEvents
        Next
        Index = Index + ReadBlock
    Loop
    SysexListCount = p
Unload Form2
If Sysexbuffer(3) <> &H6A Then                          'If Not a JV1080 file
    MsgBox (FileTitle & " Is not a JV-1080 file")
    SysexListCount = 0: BufferIndex = 0
    LoadFile = 99
Else
    SetAdjust (p)
    LoadFile = Sysexbuffer(5)   'File Type
End If
Close #1

End Function

Public Sub OpenMidi_In(Port As Integer)
Dim Index As Integer
'Dim i As Integer            'Index counter
Dim rc1, rc2 As Variant          'return code

    Index = Port
    rc1 = StopMidiIn(lpMidiIn)       'Stop & close midi in
    rc2 = CloseMidiIn(lpMidiIn)

    rc1 = OpenMidiIn(lpMidiIn, Form1.MidiSys1.hWnd, Index, ByVal 0&, MIDIIN_DEFAULT)
    rc2 = StartMidiIn(lpMidiIn)
    
    If rc1 <> 0 Or rc2 <> 0 Then MsgBox ("Unable to open MidiIn port.")
        
End Sub

Public Sub OpenMidi_Out(Port As Integer)
Dim rc1 As Variant, wDevId As Integer

    wDevId = Port
    rc1 = OpenMidiOut(lpMidiOut, Form1.MidiSys1.hWnd, wDevId, ByVal 0&, MIDIOUT_DEFAULT)
    If rc1 <> 0 Then MsgBox ("Unable to open MidiOut port.")
    
End Sub


Public Function GetPatch()
'Request a Patch & Waits until finished
Dim T0, TimeOut As Date

If GetMidiValues = 1 Then
    SysexListCount = 0
    BufferIndex = 0
    Form1.Send ("11 03 00 00 00 00 00 60 00 ") 'Get Temp Patch
    
    TimeOut = #12:00:02 AM#
    T0 = Now + TimeOut
    Do While SysexListCount < PatchLen     'Wait until received
        DoEvents
        If Now > T0 Then
            Exit Do
        End If
    Loop
    If SysexListCount = PatchLen Then
        GetPatch = True
        If Form1.OptionPatch Then           'Mark EFX in form1.efx combo
            AutoCode = 0
            Form1.EFX_Type.ListIndex = Sysexbuffer(21)
            AutoCode = 1
            '-------------xxxxxx
            ToneSet
        End If
    Else
        MsgBox ("I can't hear your JV1080")
        GetPatch = False
    End If
Else
    If SysexListCount = PatchLen Then         'File loaded
        GetPatch = True
    Else
        MsgBox ("You Have to load a Patch .")
        GetPatch = False
    End If
End If
End Function






Public Sub PostGain(Index)
If AutoCode Then
    If EFX_Caller = 0 Then
        Form1.Send ("12 03 00 00 10 " & FillCode(Hex(Index)))
    ElseIf EFX_Caller = 1 Then
        Form1.Send ("12 01 00 00 11 " & FillCode(Hex(Index)))
    End If
End If

End Sub





Public Sub WritePatch()
Dim i, Code, Index, Check As Integer
Dim Pos(5, 1) As Integer

'If QueryNames = False Then Form1.Query_Click
If GetPatch Then
        Number = -1
        Do While Number < 0 Or Number > 127
            Number = Val(InputBox$("Write to Bank Number : ")) - 1
            If Number = -1 Then Exit Sub
        Loop
        Index = 0
        For i = 0 To PatchLen - 1
            If Sysexbuffer(i) = &HF0 Then        'Create an array with STARTs & EOXs
                Pos(Index, 0) = i
            ElseIf Sysexbuffer(i) = &HF7 Then
                Pos(Index, 1) = i
                Index = Index + 1
            End If
        Next
        For i = 0 To 4                          'Make Patch Permanent
            Sysexbuffer(Pos(i, 0) + 5) = &H11
            Sysexbuffer(Pos(i, 0) + 6) = Number
        Next
        Check = 0: s = ""
        For i = 0 To 4                          'Replace checksums
            For j = Pos(i, 0) + 5 To Pos(i, 1) - 2
                Code = Sysexbuffer(j)
                Check = Check + Sysexbuffer(j)
            Next
            Check = 128 - ((Check + 128) Mod 128)
            Sysexbuffer(Pos(i, 1) - 1) = Check
            Check = 0
        Next
        Form1.Send_Sysex_Click                   'Send Patch
Else
    MsgBox ("I can't hear your JV1080")
End If
End Sub


